@echo off
if not %cmdextversion%.==. goto isExt
if not %os%.==Windows_NT. goto noExtensions
verify other 2>nul
setlocal enableextensions
if errorlevel 1 goto noExtensions
:isExt

setlocal
set "to_nul= > nul"
if /i "%~1" == "DEBUG" (
	echo on
	set to_nul=
)
if "%temp:~-1%"=="\" set "temp=%temp:~0,-1%"

if defined PROCESSOR_ARCHITEW6432 goto wow64

set finddir=
find /? > nul 2> nul
if not errorlevel 1 goto start
rem Try directory where %comspec% is located
for %%P in ( %comspec% ) do (
	%%~dpPfind.exe /? > nul 2> nul
	if not errorlevel 1 (
		path %%~dpP;%windir%;%%~dpPwbem;%path%
		set finddir=%%~dpP
		goto start
	)
)
echo FIND.EXE not found or a non-Windows version of FIND.EXE found first in PATH!
echo Please make sure that environmental variable PATH lists Windows command
echo   line utilities directory (System32 or System under %%systemroot%%) _before_
echo   other directories (Unix/Linux?) containing similarly named files.
echo Installation terminated.
pause
goto veryend



:mk_dir
setlocal
set dir2make="%~1"

dir /ad %dir2make% 2>nul |"%finddir%find" " .."%to_nul%
if not errorlevel 1 (
	endlocal
	goto :eof
)
mkdir %dir2make%
dir /ad %dir2make% 2>nul |"%finddir%find" " .."%to_nul%
if errorlevel 1 (
	if not "%~2"=="" echo %~2 %dir2make%
	echo  Press Enter to finish.&set /p dummy=
	exit /b 1
)
goto :eof



:instPart
rem usage: call :instPart destdir verfile partname pathInCab
set destdir=%~1
set verfile=%~2
call :mk_dir "%destdir%" "Unable to create directory" || exit /b 1

if not exist "%destdir%\%verfile%" goto noinst
set partversion=
for /f "eol= usebackq tokens=2" %%i in (
	`type "%destdir%\%verfile%" ^| findstr /bl $version$`
	) do set partversion=%%i
if not defined partversion goto noinst


set newversion=
for /f "eol= usebackq tokens=2 delims=|" %%v in (`type "%temp%\PAversions" ^| "%finddir%find" /i "%verfile%"`) do set newversion=%%v
if not defined newversion (
	echo  Installation file %cabfile% is invalid. Installation canceled.
	echo  Press Enter to finish.&set /p dummy=
	exit /b 1
)

if %newversion% geq %partversion% goto noinst
echo.
echo A newer version of %~3 is already installed.
call "%temp%\choice2" /d:N choice "Do you really want to overwrite it with an older version?"
if /i not "%choice%"=="Y" exit /b 0

:noinst

echo  Installing %~3 files...
for /f "eol= delims=| tokens=1" %%f in ('type "%temp%\FileList_PA" ^| "%finddir%find" "|%~4"') do (
	expand %cabfile% -F:"%%f" "%destdir%"%to_nul%
)

verify off > nul
if not "%~3"=="Database Groups utility" goto :eof
if defined partversion goto :eof
if not exist "%appdata%" goto :eof
if exist "%appdata%\BSUtils\for Oracle\DB Groups" goto :eof
if exist "%appdata%\BSUtils\for Oracle\DB Sets" (
	rename "%appdata%\BSUtils\for Oracle\DB Sets" "DB Groups"
) else if exist "%appdata%\BSUtils\for Oracle\DB Lists" rename "%appdata%\BSUtils\for Oracle\DB Lists" "DB Groups"
goto :eof



:start
title PassAid Install

set cabfile="PassAid.cab"
set exppath=
for %%f in (expand.exe) do set exppath=%%~$path:f
if not defined exppath (
	echo Required utility expand.exe not found in Windows %%PATH%%.
	echo  Installation canceled.
	echo  Press Enter to finish.&set /p dummy=
	goto :eof
)

set InstDir=%~dp0
pushd %InstDir%
if not exist %cabfile% (
	echo  PassAid installation file %cabfile% not found.
	echo  Installation canceled.
	echo  Press Enter to finish.&set /p dummy=
	popd
	goto :eof
)

expand -d %cabfile% -f:PassAid.bat "for Oracle\PassAid" | "%finddir%find" "'."%to_nul% && (
	echo  PassAid installation file %cabfile% is invalid.
	echo  Installation canceled.
	echo  Press Enter to finish.&set /p dummy=
	popd
	goto :eof
)
	
expand %cabfile% -f:choice2.bat "%temp%" | "%finddir%find" "'."%to_nul% && (
	echo  PassAid installation file %cabfile% is invalid.
	echo  Installation canceled.
	echo  Press Enter to finish.&set /p dummy=
	if exist "%temp%\choice2.bat" del "%temp%\choice2.bat"
	popd
	goto :eof
)

expand %cabfile% -f:UpperASCII.re "%temp%" | "%finddir%find" "'."%to_nul% && (
	echo  PassAid installation file %cabfile% is invalid.
	echo  Installation canceled.
	echo  Press Enter to finish.&set /p dummy=
	if exist "%temp%\choice2.bat" del "%temp%\choice2.bat"
	popd
	goto :eof
)

expand %cabfile% -f:PAversions "%temp%" | "%finddir%find" "'."%to_nul% && goto cabInvalid

set PAiversion=
for /f "eol= usebackq tokens=2 delims=|" %%v in (`type "%temp%\PAversions" ^| "%finddir%find" /i "PassAid0.bat"`) do set PAiversion=%%v
if not defined PAiversion goto cabInvalid

expand %cabfile% -f:Installl.bat "%temp%" | "%finddir%find" "'."%to_nul% && goto cabInvalid

echo  BS Utilities for Oracle databases
echo  PassAid Installation

echo.
echo  Please make sure no instances of PassAid are running before reinstalling.
call "%temp%\choice2" choice " Do you want to install/reinstall PassAid version %PAiversion% ?"
if /i not "%choice%"=="Y" goto end

if not exist "%ProgramFiles%\BSUtils\for Oracle\PassAid\PassAid.bat" (
	if not exist "%USERPROFILE%\Local Settings\Application Data\BSUtils\for Oracle\PassAid\PassAid.bat" (
		goto noinstances
	)
)

tasklist >nul 2>nul
if not errorlevel 1 (
	tasklist /v /fo csv 2>nul | findstr /e "PassAid""" %to_nul%
	if not errorlevel 1 (
		echo  Instances of PassAid are running. Installation canceled.
		echo  Press Enter to finish.
		set /p dummy=
		goto end
	)
	goto noinstances
)

tlist >nul 2>nul
if not errorlevel 1 (
	tlist 2>nul | findstr /e "PassAid" %to_nul%
	if not errorlevel 1 (
		echo  Instances of PassAid are running. Installation canceled.
		echo  Press Enter to finish.
		set /p dummy=
		goto end
	)
	goto noinstances
)

rem no working tasklist/tlist found

:noinstances

set quit=N
call "%temp%\Installl.bat"
if not %quit%==N goto end

set tmpname="%ProgramFiles%\tmp%random%.tmp"
(echo.> %tmpname% ) 2>nul
if not exist %tmpname% (
	verify off
	set instProfile=P
	set InstallDir=%USERPROFILE%\Local Settings\Application Data
	goto isInstDir
)
del %tmpname%

echo.
echo   Where do you want to install PassAid?
echo.
echo     1. In "%ProgramFiles%" (available to all users of this computer;
echo                 may require local administrator rights)
echo     2. In your personal profile
echo     3. Cancel installation
echo.
if exist "%ProgramFiles%\BSUtils\for Oracle\PassAid" echo A version of PassAid is found in "%ProgramFiles%".
if exist "%USERPROFILE%\Local Settings\Application Data\BSUtils\for Oracle\PassAid" (
	echo A version of PassAid is found in your personal  profile. )
echo.
call "%temp%\choice2" /c:123 choice " Where do you want to install PassAid? "
if "%choice%"=="3" goto end
if "%choice%"=="1" (
	set instProfile=C
	set InstallDir=%ProgramFiles%
)
if "%choice%"=="2" (
	set instProfile=P
	set InstallDir=%USERPROFILE%\Local Settings\Application Data
)

:isInstDir
expand %cabfile% -f:FileList_PA "%temp%" | "%finddir%find" "'."%to_nul% && goto cabInvalid

expand %cabfile% -f:modilnk.vbs "%temp%" | "%finddir%find" "'."%to_nul% && goto cabInvalid

call :mk_dir "%InstallDir%\BSUtils" "Unable to create directory" || goto end

rem if file does not exist, just continue
expand %cabfile% -f:gpl.html "%InstallDir%\BSUtils"%to_nul%

call :mk_dir "%InstallDir%\BSUtils\for Oracle" "Unable to create directory" || goto end

set destdir=%InstallDir%\BSUtils\EnterPwd
call :instPart "%destdir%" EnterPwd.bat "EnterPwd utility" "EnterPwd" || goto end

call :instPart "%InstallDir%\BSUtils\for Oracle\PassAid" PassAid0.bat "PassAid" "for Oracle\PassAid" || goto end

call :instPart "%InstallDir%\BSUtils\for Oracle\DB Groups" DBlists.bat "Database Groups utility" "for Oracle\DB Groups" || goto end

call :instPart "%InstallDir%\BSUtils\Utils" mpicker.bat "BSUtils Utilities" "Utils" || goto end

echo  Installing shortcuts...

call :mk_dir "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle" "Unable to create directory" || goto end

call :mk_dir "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle\PassAid" "Unable to create directory" || goto end

call :del_file "%InstallDir%\BSUtils\for Oracle\PassAid\history.txt"
call :del_file "%InstallDir%\BSUtils\Utils\up"
call :del_file "%InstallDir%\BSUtils\Utils\up2"
call :del_file "%InstallDir%\BSUtils\Utils\up2.bat"
call :del_file "%InstallDir%\BSUtils\Utils\tnsnames.ora"
call :del_file "%InstallDir%\BSUtils\Utils\UppercaseASCII.rex"
call :del_file "%InstallDir%\BSUtils\Utils\sp1.csv"
call :del_file "%InstallDir%\BSUtils\Utils\sp1.csv"
call :del_file "%InstallDir%\BSUtils\Utils\sp1.lst"
call :del_file "%InstallDir%\BSUtils\Utils\sp1-1251.csv"
call :del_file "%InstallDir%\BSUtils\Utils\RUS.oralang"
call :del_file "%InstallDir%\BSUtils\Utils\htm2csv.bat"

verify off
if %instProfile%==C (
	expand %cabfile% -f:PassAid.lnk "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle\PassAid"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	expand %cabfile% -f:"Uninstall PassAid.lnk" "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle\PassAid"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	expand %cabfile% -f:"Database Groups.lnk" "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle"| "%finddir%find" "'."%to_nul% && goto cabInvalid

	pushd "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle"
	if exist "PassAid\Uninstall.lnk" del "PassAid\Uninstall.lnk"
	cscript //nologo "%temp%\modilnk.vbs" "PassAid\PassAid.lnk" "%ProgramFiles%\BSUtils\for Oracle\PassAid\PassAid.ico"
rem	cscript //nologo "%temp%\modilnk.vbs" "PassAid\Uninstall PassAid.lnk" "%SystemRoot%\system32\SHELL32.dll,?"
	cscript //nologo "%temp%\modilnk.vbs" "Database Groups.lnk" "%ProgramFiles%\BSUtils\for Oracle\DB Groups\DB_Groups.ico"
	popd
) else (
	expand %cabfile% -f:PassAid_Personal.lnk "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle\PassAid"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	expand %cabfile% -f:"Uninstall PassAid_Personal.lnk" "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle\PassAid"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	expand %cabfile% -f:"Database Groups_Personal.lnk" "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle"| "%finddir%find" "'."%to_nul% && goto cabInvalid

	pushd "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle"
	if exist "PassAid\PassAid.lnk" del "PassAid\PassAid.lnk"
	rename "PassAid\PassAid_Personal.lnk" "PassAid.lnk" %to_nul%
	if exist "PassAid\Uninstall PassAid.lnk" del "PassAid\Uninstall PassAid.lnk"
	rename "PassAid\Uninstall PassAid_Personal.lnk" "Uninstall PassAid.lnk" %to_nul%
	if exist "Database Groups.lnk" del "Database Groups.lnk"
	rename "Database Groups_Personal.lnk" "Database Groups.lnk" %to_nul%
	cscript //nologo "%temp%\modilnk.vbs" "PassAid\PassAid.lnk" "%USERPROFILE%\Local Settings\Application Data\BSUtils\for Oracle\PassAid\PassAid.ico"
rem	cscript //nologo "%temp%\modilnk.vbs" "PassAid\Uninstall PassAid.lnk" "%SystemRoot%\system32\SHELL32.dll,?"
	cscript //nologo "%temp%\modilnk.vbs" "Database Groups.lnk" "%USERPROFILE%\Local Settings\Application Data\BSUtils\for Oracle\DB Groups\DB_Groups.ico"
	popd
)


rem ver | "%finddir%find" "Windows 2000"%to_nul%
rem if not errorlevel 1 goto w2k
rem for %%f in (tasklist.exe) do if not "%%~$path:f"=="" goto afterw2k

rem :w2k
rem for /f "eol=" %%p in ("reg.exe") do if exist "%%~$PATH:p" goto afterw2k
rem if %instProfile%==C (
rem 	for /f "eol=" %%p in ("findstr.exe") do set Wutilsdir=%%~dp$PATH:p
rem 	if "%Wutilsdir:~-1%"=="\" set Wutilsdir=%Wutilsdir:~0,-1%
rem 	expand %cabfile% -f:reg.exe "%Wutilsdir%"| "%finddir%find" "'."%to_nul% && cabInvalid
rem ) else (
rem 	expand %cabfile% -f:reg.exe "%USERPROFILE%\Local Settings\Application Data\BSUtils\Utils"| "%finddir%find" "'."%to_nul% && goto cabInvalid
rem )
rem :afterw2k


for /f "eol=" %%p in ("reg.exe") do if not "%%~$PATH:p"=="" goto afterreg
if %instProfile%==P (
	expand %cabfile% -f:reg.exe "%USERPROFILE%\Local Settings\Application Data\BSUtils\Utils"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	goto afterreg
)
for /f "eol=" %%p in ("findstr.exe") do set Wutilsdir=%%~dp$PATH:p
if "%Wutilsdir:~-1%"=="\" set Wutilsdir=%Wutilsdir:~0,-1%
expand %cabfile% -f:reg.exe "%Wutilsdir%"| "%finddir%find" "'."%to_nul% && goto cabInvalid

:afterreg

if exist "%USERPROFILE%\Desktop\PassAid.lnk" goto copyLNK
echo.
call "%temp%\choice2" /d:Y choice " Do you want to create a desktop shortcut to PassAid?"
if /i not "%choice%"=="Y" goto afterLNK
:copyLNK
if %instProfile%==C (
	expand %cabfile% -f:PassAid.lnk "%USERPROFILE%\Desktop"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	cscript //nologo "%temp%\modilnk.vbs" "%USERPROFILE%\Desktop\PassAid.lnk" "%ProgramFiles%\BSUtils\for Oracle\PassAid\PassAid.ico"
) else (
	expand %cabfile% -f:PassAid_Personal.lnk "%USERPROFILE%\Desktop"| "%finddir%find" "'."%to_nul% && goto cabInvalid
	if exist "%USERPROFILE%\Desktop\PassAid.lnk" del "%USERPROFILE%\Desktop\PassAid.lnk"
	rename "%USERPROFILE%\Desktop\PassAid_Personal.lnk" "PassAid.lnk"
	cscript //nologo "%temp%\modilnk.vbs" "%USERPROFILE%\Desktop\PassAid.lnk" "%USERPROFILE%\Local Settings\Application Data\BSUtils\for Oracle\PassAid\PassAid.ico"
)
:afterLNK



:lnktest
echo  Verifying installation...
expand %cabfile% -f:lnktest.* "%TEMP%"| "%finddir%find" "'."%to_nul% && (pause & goto end)
echo.>"%TEMP%\lnktest.tmp"
rem start "LNKtest" /min /wait "%TEMP%\lnktest.js"
start "LNKtest" /min "%TEMP%\lnktest.lnk"
call "%InstallDir%\BSUtils\Utils\wait" 2
if exist "%TEMP%\lnktest.tmp" (
	rem lnk not started
	del "%TEMP%\lnktest.tmp"
	echo.
	set /p dummy=Installation complete. Press Enter to finish.
	goto end
)

echo  Installation complete.
echo.
call "%temp%\choice2" /d:Y choice " Do you want to start PassAid now?"
if /i not "%choice%"=="Y" goto end

rem expand %cabfile% -f:runPA.js "%temp%" | "%finddir%find" "'."%to_nul% && goto cabInvalid
rem start " " "%temp%\runPA.js"
start "PassAid" /i "%USERPROFILE%\Start Menu\Programs\BS Utilities for Oracle\PassAid\PassAid.lnk"

call "%InstallDir%\BSUtils\Utils\wait" 3
goto end


:cabInvalid
echo  PassAid installation file %cabfile% is invalid.
echo  Installation canceled.
echo  Press Enter to finish.
set /p dummy=
goto end


:wow64
echo This installation program was started from a 32-bit application on a
echo 64-bit system. Please restart the program in the native 64-bit environment.
echo Installation canceled.
echo Press Enter to finish.
set /p dummy=
goto veryend


:noExtensions
if not %os%.==Windows_NT. echo  The installer does not support operating systems older than Windows 2000.
if %os%.==Windows_NT. echo  Command Extensions are not enabled. Consult Windows documentation
if %os%.==Windows_NT. echo  on how to enable Command Extensions. Installation cancelled.
pause
goto veryend


:del_file
if not "%~1"=="" if exist "%~1" del "%~1"
goto :eof


:end
call :del_file "%temp%\choice2.bat"
call :del_file "%temp%\UpperASCII.re"
call :del_file "%temp%\PAversions"
call :del_file "%temp%\Installl.bat"
call :del_file "%temp%\gpl.html"
rem call :del_file "%temp%\runPA.js"
call :del_file "%temp%\FileList_PA" 
rem call :del_file "%temp%\lnktest.js"
call :del_file "%temp%\lnktest.lnk"
call :del_file "%temp%\lnktest.bat"
call :del_file "%temp%\modilnk.vbs"
popd
endlocal
:veryend